<?php
/**
 * Optin
 * 
 * @package
 */
namespace WPFunnels\Widgets\Oxygen;

use CT_Text_Block;
use WPFunnels\Wpfnl_functions;

/**
 * Class Optin
 *
 * @package WPFunnels\Widgets\Oxygen
 */
class Optin extends Elements {

    function init() {
        // Do some initial things here.
    }

    function afterInit() {
        // Do things after init, like remove apply params button and remove the add button.
        $this->removeApplyParamsButton();
        // $this->removeAddButton();
    }

    function name() {
        return 'WPF Optin';
    }

    function slug() {
        return "wpfnl-optin";
    }

    function icon() {
		return	plugin_dir_url(__FILE__) . 'icon/optin_form.svg';
    }

//    function button_place() {
//        // return "interactive";
//    }

    function button_priority() {
        // return 9;
    }


    function render($options, $defaults, $content) {
		if (Wpfnl_functions::check_if_this_is_step_type('checkout') || Wpfnl_functions::check_if_this_is_step_type('upsell') || Wpfnl_functions::check_if_this_is_step_type('downsell') || Wpfnl_functions::check_if_this_is_step_type('thankyou')){
			echo __('Sorry, Please place the element in WPFunnels Landing page','wpfnl');
		}

		else{

        $step_id = isset($_GET['post_id']) ? $_GET['post_id'] : get_the_ID();
        $layout 					= $options['layout'] ;
        $first_name 				= $options['first_name'] == 'on' ? 'true' : false;
        $last_name 					= $options['last_name'] == 'on' ? 'true' : false;
        $acceptance_checkbox 		= $options['acceptance_checkbox'] == 'on' ? 'true' : false;
        $input_field_icon			= $options['input_fields_icon'] == 'on' ? 'true' : false;
        $field_label 				= $options['field_label'] == 'on' ? 'true' : false;
        $admin_email 				= $options['admin_email'];
        $admin_email_subject 		= $options['admin_email_subject'];
        $notification_text 			= $options['notification_text'];
        $other_action 				= $options['other_action'];
        $redirect_url 				= $options['redirect_url'];

        $button_text           		= $options['button_text'];
		$recaptcha_setting			= Wpfnl_functions::get_recaptcha_settings();
		$is_recaptch 			= isset($recaptcha_setting['enable_recaptcha']) ? $recaptcha_setting['enable_recaptcha'] : '';
		$site_key 				= isset($recaptcha_setting['recaptcha_site_key']) ? $recaptcha_setting['recaptcha_site_key'] : '';
		$site_secret_key 		= isset($recaptcha_setting['recaptcha_site_secret']) ? $recaptcha_setting['recaptcha_site_secret'] : '';
		$token_input 				= '';
		$recaptch_script 			= '';
		$is_recaptch_input 			= '';
		$token_secret_key 			= '';
		if('on' == $is_recaptch && '' != $site_key &&  '' != $site_secret_key){
			$is_recaptch_input 		= '<input type="hidden" id="wpf-is-recapcha" name="wpf-is-recapcha" value="'.$is_recaptch.'"/>';
			$token_input 			= '<input type="hidden" id="wpf-optin-g-token" name="wpf-optin-g-token" />';
			$token_secret_key 		= '<input type="hidden" id="wpf-optin-g-secret-key" name="wpf-optin-g-secret-key" value="'.$site_secret_key.'" />';
			$recaptch_script 		= '<script src="https://www.google.com/recaptcha/api.js?render='.$site_key.'"></script>';
		}
        ?>
			<?php echo $recaptch_script;  ?>
        <div class="wpfnl-optin-form wpfnl-shortcode-optin-form-wrapper" >
            <form method="post">
                <input type="hidden" name="post_id" value="<?php echo $step_id; ?>" />
                <input type="hidden" name="admin_email" value="<?php echo $admin_email; ?>" />
                <input type="hidden" name="admin_email_subject" value="<?php echo $admin_email_subject; ?>" />
                <input type="hidden" name="redirect_url" value="<?php echo $redirect_url; ?>" />
                <input type="hidden" name="notification_text" value="<?php echo $notification_text; ?>" />
                <input type="hidden" name="post_action" value="<?php echo $other_action; ?>" />

				<?php
				echo $is_recaptch_input;
				echo $token_input;
				echo $token_secret_key;
				?>
                <div class="wpfnl-optin-form-wrapper <?php echo $layout; ?>" >
                    <?php if( 'on' == $options['first_name'] ){ ?>
                        <div class="wpfnl-optin-form-group first-name">

                            <?php if( 'on' == $options['field_label'] ){ ?>
                                <label for="wpfnl-first-name">
                                    <?php
                                    echo $options['first_name_label'] ? $options['first_name_label'] : __('First Name','wpfnl');

                                    if( 'on' == $options['field_required_mark'] && 'on' == $options['is_required_name'] ){ ?>
                                        <span class="required-mark">*</span>
                                    <?php } ?>
                                </label>
                            <?php } ?>

                            <span class="input-wrapper">
                                <?php if( 'on' == $options['input_fields_icon'] ){ ?>
                                    <span class="field-icon">
                                        <img src="<?php echo WPFNL_DIR_URL.'/public/assets/images/user-icon.svg'; ?>" alt="icon">
                                    </span>
                                <?php } 
                                    $f_name_placeholder = isset($options['first_name_placeholder']) ? $options['first_name_placeholder'] : '';
                                ?>
                                <input type="text" name="first_name" id="wpfnl-first-name" class="wpfnl-first-name" placeholder="<?php echo $f_name_placeholder; ?>" <?php echo 'on' == $options['is_required_name'] ? 'required' : ''; ?>/>
                            </span>

                        </div>
                    <?php } ?>

                    <?php if( 'on' == $options['last_name'] ){ ?>
                        <div class="wpfnl-optin-form-group last-name">

                            <?php if( 'on' == $options['field_label'] ){ ?>
                                <label for="wpfnl-last-name">
                                    <?php
                                    echo $options['last_name_label'] ? $options['last_name_label'] : __('Last Name','wpfnl');

                                    if( 'on' == $options['field_required_mark'] && 'on' == $options['is_required_last_name'] ){ ?>
                                        <span class="required-mark">*</span>
                                    <?php } ?>
                                </label>
                            <?php } ?>

                            <span class="input-wrapper">
                                <?php if( 'on' == $options['input_fields_icon'] ){ ?>
                                    <span class="field-icon">
                                        <img src="<?php echo WPFNL_DIR_URL.'/public/assets/images/user-icon.svg'; ?>" alt="icon">
                                    </span>
                                <?php } 
                                    $l_name_placeholder = isset($options['last_name_placeholder']) ? $options['last_name_placeholder'] : '';
                                ?>
                                <input type="text" name="last_name" id="wpfnl-last-name" class="wpfnl-last-name" placeholder="<?php echo $l_name_placeholder; ?>" <?php echo 'on' == $options['is_required_last_name'] ? 'required' : ''; ?>/>
                            </span>
                        </div>
                    <?php } ?>


                    <div class="wpfnl-optin-form-group email">
                        <?php if( 'on' == $options['field_label'] ){ ?>
                            <label for="wpfnl-email">
                                <?php
                                echo $options['email_label'] ? $options['email_label'] : __('Email','wpfnl');
                                if( 'on' == $options['field_required_mark'] ){ ?>
                                    <span class="required-mark">*</span>
                                <?php } ?>
                            </label>
                        <?php } ?>
                        <span class="input-wrapper">
                            <?php if( 'on' == $options['input_fields_icon'] ){ ?>
                                <span class="field-icon">
                                    <img src="<?php echo WPFNL_DIR_URL.'/public/assets/images/email-open-icon.svg'; ?>" alt="icon">
                                </span>
                            <?php } 
                                $email_placeholder = isset($options['email_placeholder']) ? $options['email_placeholder'] : '';
                            ?>
                            <input type="email" name="email" id="wpfnl-email" class="wpfnl-email"placeholder="<?php echo $email_placeholder; ?>" pattern="[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,}$" required />
                        </span>
                    </div>

					<?php if( 'on' == $options['phone'] ){ ?>
						<div class="wpfnl-optin-form-group phone">

							<?php if( 'on' == $options['field_label'] ){ ?>
								<label for="wpfnl-phone">
									<?php
                                    echo $options['phone_label'] ? $options['phone_label'] : __('Phone','wpfnl');

                                    if( 'on' == $options['field_required_mark'] && 'on' == $options['is_required_phone'] ){ ?>
										<span class="required-mark">*</span>
									<?php } ?>
								</label>
							<?php } ?>

							<span class="input-wrapper">
                                <?php if( 'on' == $options['input_fields_icon'] ){ ?>
									<span class="field-icon">
                                        <img src="<?php echo WPFNL_DIR_URL.'/public/assets/images/phone.svg'; ?>" alt="icon">
                                    </span>
								<?php } 
                                    $phone_placeholder = isset($options['phone_placeholder']) ? $options['phone_placeholder'] : '';
                                ?>
                                <input type="text" name="phone" id="wpfnl-phone" class="wpfnl-phone" placeholder="<?php echo $phone_placeholder; ?>" <?php echo 'on' == $options['is_required_phone'] ? 'required' : ''; ?> />
                            </span>
						</div>
					<?php } ?>

					<?php if( 'on' == $options['website_url'] ){ ?>
						<div class="wpfnl-optin-form-group web-url">

							<?php if( 'on' == $options['field_label'] ){ ?>
								<label for="web-url">
									<?php
                                    echo $options['website_url_label'] ? $options['website_url_label'] : __('Website Url','wpfnl');

                                    if( 'on' == $options['field_required_mark'] && 'on' == $options['is_required_website_url'] ){ ?>
										<span class="required-mark">*</span>
									<?php } ?>
								</label>
							<?php } ?>

							<span class="input-wrapper">
                                <?php if( 'on' == $options['input_fields_icon'] ){ ?>
									<span class="field-icon">
                                        <img src="<?php echo WPFNL_DIR_URL.'/public/assets/images/web-url.svg'; ?>" alt="icon">
                                    </span>
								<?php } 
                                    $weburl_placeholder = isset($options['website_url_placeholder']) ? $options['website_url_placeholder'] : '';
                                ?>
                                <input type="text" name="web-url" id="wpfnl-web-url" class="wpfnl-web-url" pattern="https?://.+" size="30" placeholder="<?php echo $weburl_placeholder; ?>" <?php echo 'on' == $options['is_required_website_url'] ? 'required' : ''; ?>/>
                            </span>
						</div>
					<?php } ?>

					<?php if( 'on' == $options['message'] ){ ?>
						<div class="wpfnl-optin-form-group message">

							<?php if( 'on' == $options['field_label'] ){ ?>
								<label for="wpfnl-message">
									<?php
                                    echo $options['message_label'] ? $options['message_label'] : __('Message','wpfnl');

                                    if( 'on' == $options['field_required_mark'] && 'on' == $options['is_required_message'] ){ ?>
										<span class="required-mark">*</span>
									<?php } ?>
								</label>
							<?php } 
                                $message_placeholder = isset($options['message_placeholder']) ? $options['message_placeholder'] : '';
                            ?>

							<span class="input-wrapper">
                                <textarea name="message" id="wpfnl-message" class="wpfnl-message" cols="30" rows="3" placeholder="<?php echo $message_placeholder; ?>" <?php echo 'on' == $options['is_required_message'] ? 'required' : ''; ?> ></textarea>
                            </span>
						</div>
					<?php } ?>

                    <?php
                    if( 'on' == $options['acceptance_checkbox'] ){
                        ?>
                        <div class="wpfnl-optin-form-group acceptance-checkbox">
                            <input type="checkbox" name="acceptance_checkbox" class="wpfnl-acceptance_checkbox" id="wpfnl-acceptance_checkbox-<?php echo esc_attr( $step_id ); ?>" <?php echo 'on' == $options['is_required_acceptance'] ? 'required' : ''; ?> />
                            <label for="wpfnl-acceptance_checkbox-<?php echo esc_attr( $step_id ); ?>">
                                <span class="check-box"></span>
                                <?php
                                echo $options['acceptance_checkbox_text'];

                                if( 'on' == $options['field_required_mark'] && 'on' == $options['is_required_acceptance'] ){
                                    echo '<span class="required-mark">*</span>';
                                }
                                ?>
                            </label>
                        </div>
                        <?php
                    }
                    ?>
					<?php
                    if( 'on' == $options['data_to_checkout'] ){
						?>
						<input type="hidden" name="data_to_checkout" value="<?php echo esc_attr( 'yes' ); ?>"/>
						<?php
					}

					if( 'on' == $options['register_as_subscriber'] ){
						?>
						<input type="hidden" name="optin_allow_registration" value="<?php echo esc_attr( 'yes' ); ?>"/>
						<?php
						if ('on' == $options['subscription_permission']){
							?>
							<div class="wpfnl-optin-form-group user-registration-checkbox">
								<input type="checkbox" name="user_registration_checkbox" class="wpfnl-registration_checkbox" id="wpfnl-registration_checkbox-<?php echo esc_attr( $step_id ); ?>" required/>
								<label for="wpfnl-registration_checkbox-<?php echo esc_attr( $step_id ); ?>">
									<span class="check-box"></span>
									<?php
									echo $options['subscription_permission_text'];
									?>
									<span class="required-mark">*</span>
								</label>
							</div>
							<?php
						}
					}
					?>

                    <div class="wpfnl-optin-form-group submit align-center">
                        <button type="submit" class="btn-optin-oxygen btn-optin">
                            <?php echo $options['button_text'] ?>
                            <span class="wpfnl-loader"></span>
                        </button>
                    </div>
                </div>
            </form>
			<?php
			if('on' == $is_recaptch && '' != $site_key &&  '' != $site_secret_key){?>
				<script>
					grecaptcha.ready(function() {
						grecaptcha.execute('<?php echo $site_key ?>', {action: 'homepage'}).then(function(token) {
							document.getElementById("wpf-optin-g-token").value = token;
						});
					});
				</script>
				<?php
			}
			?>
            <div class="response"></div>
        </div>
        <?php
		}

    }
    function controls() {
        // Layout
        $layout = $this->addControlSection("optin_layout", __("Layout","wpfnl"), "assets/icon.png", $this);
        $layout->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Layout","wpfnl"),
                "slug" => 'layout',
                "default" => ""
            )
        )->setValue(array(
            ''       			=> __( 'Default Style',"wpfnl" ),
            'form-style1'       => __( 'Form Style-1',"wpfnl" ),
            'form-style2'       => __( 'Form Style-2',"wpfnl" ),
            'form-style3'   	=> __( 'Form Style-3',"wpfnl" ),
            'form-style4'   	=> __( 'Form Style-4',"wpfnl" ),
        ))->rebuildElementOnChange();

        $form_field = $this->addControlSection("optin_form_field", __("Form Fields","wpfnl"), "assets/icon.png", $this);

        //first name
        $field_first_name = $form_field->addControlSection("field_first_name", __("First Name","wpfnl"), "assets/icon.png", $this);
        $field_first_name->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Enable First  Name","wpfnl"),
                "slug" => 'first_name',
                "default" => "off"
            )
        )->setValue(array(
            'on'       => __('Yes' ,"wpfnl"),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();

        //First Name label
        $field_first_name->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("First Name Label","wpfnl"),
                "slug" => 'first_name_label',
                "default" => __("First Name","wpfnl"),
                "condition" => 'first_name=on',
            )
        )->rebuildElementOnChange();

        $field_first_name->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("First Name Placeholder Text","wpfnl"),
                "slug" => 'first_name_placeholder',
                "default" => __("First Name","wpfnl"),
                "condition" => 'first_name=on',
            )
        )->rebuildElementOnChange();

        $field_first_name->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Mark First Name As Required","wpfnl"),
                "slug" => 'is_required_name',
                "default" => "off",
                "condition" => 'first_name=on',
            )
        )->setValue(array(
            'on'       => __('Yes' ,"wpfnl"),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();


        //Last Name
        $field_last_name = $form_field->addControlSection("field_last_name", __("Last Name","wpfnl"), "assets/icon.png", $this);
        $field_last_name->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Enable Last Name","wpfnl"),
                "slug" => 'last_name',
                "default" => "off"
            )
        )->setValue(array(
            'on'       => __('Yes',"wpfnl" ),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();

        //Last Name label
        $field_last_name->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Last Name Label","wpfnl"),
                "slug" => 'last_name_label',
                "default" => __("Last Name","wpfnl"),
                "condition" => 'last_name=on',
            )
        )->rebuildElementOnChange();

        $field_last_name->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Last Name Placeholder Text","wpfnl"),
                "slug" => 'last_name_placeholder',
                "default" => __("Last Name","wpfnl"),
                "condition" => 'last_name=on',
            )
        )->rebuildElementOnChange();

        $field_last_name->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Mark Last Name As Required","wpfnl"),
                "slug" => 'is_required_last_name',
                "default" => "off",
                "condition" => 'last_name=on',
            )
        )->setValue(array(
            'on'       => __('Yes' ,"wpfnl"),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();


        //Email label
        $field_email = $form_field->addControlSection("field_email", __("Email","wpfnl"), "assets/icon.png", $this);
        $field_email->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Email Label","wpfnl"),
                "slug" => 'email_label',
                "default" => __("Email","wpfnl"),
            )
        )->rebuildElementOnChange();

        $field_email->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Email Placeholder Text","wpfnl"),
                "slug" => 'email_placeholder',
                "default" => __("Email","wpfnl"),
            )
        )->rebuildElementOnChange();

        //phone
        $field_phone = $form_field->addControlSection("field_phone", __("Phone","wpfnl"), "assets/icon.png", $this);
        $field_phone->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Enable Phone","wpfnl"),
                "slug" => 'phone',
                "default" => "off"
            )
        )->setValue(array(
            'on'       => __('Yes',"wpfnl" ),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();

        //phone label
        $field_phone->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Phone Label","wpfnl"),
                "slug" => 'phone_label',
                "default" => __("Phone","wpfnl"),
                "condition" => 'phone=on',
            )
        )->rebuildElementOnChange();

        $field_phone->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Phone Placeholder Text","wpfnl"),
                "slug" => 'phone_placeholder',
                "default" => __("Phone","wpfnl"),
                "condition" => 'phone=on',
            )
        )->rebuildElementOnChange();

        $field_phone->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Mark Phone As Required","wpfnl"),
                "slug" => 'is_required_phone',
                "default" => "off",
                "condition" => 'phone=on',
            )
        )->setValue(array(
            'on'       => __('Yes' ,"wpfnl"),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();


        //website url
        $field_website_url = $form_field->addControlSection("field_website_url", __("Website Url","wpfnl"), "assets/icon.png", $this);
        $field_website_url->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Website Url","wpfnl"),
                "slug" => 'website_url',
                "default" => "off"
            )
        )->setValue(array(
            'on'       => __('Yes',"wpfnl" ),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();

        //website label
        $field_website_url->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Website Url Label","wpfnl"),
                "slug" => 'website_url_label',
                "default" => __("Website Url","wpfnl"),
                "condition" => 'website_url=on',
            )
        )->rebuildElementOnChange();

        $field_website_url->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Website Url Placeholder Text","wpfnl"),
                "slug" => 'website_url_placeholder',
                "default" => __("Website Url","wpfnl"),
                "condition" => 'website_url=on',
            )
        )->rebuildElementOnChange();

        $field_website_url->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Mark Website Url As Required","wpfnl"),
                "slug" => 'is_required_website_url',
                "default" => "off",
                "condition" => 'website_url=on',
            )
        )->setValue(array(
            'on'       => __('Yes' ,"wpfnl"),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();


        //message
        $field_message = $form_field->addControlSection("field_message", __("Message","wpfnl"), "assets/icon.png", $this);
        $field_message->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Message","wpfnl"),
                "slug" => 'message',
                "default" => "off"
            )
        )->setValue(array(
            'on'       => __('Yes',"wpfnl" ),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();


        //Message label
        $field_message->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Message Label","wpfnl"),
                "slug" => 'message_label',
                "default" => __("Message","wpfnl"),
                "condition" => 'message=on',
            )
        )->rebuildElementOnChange();

        $field_message->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Message Placeholder Text","wpfnl"),
                "slug" => 'message_placeholder',
                "default" => __("Message","wpfnl"),
                "condition" => 'message=on',
            )
        )->rebuildElementOnChange();

        $field_message->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Mark Message As Required","wpfnl"),
                "slug" => 'is_required_message',
                "default" => "off",
                "condition" => 'message=on',
            )
        )->setValue(array(
            'on'       => __('Yes' ,"wpfnl"),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();


        //Acceptance
        $field_acceptance = $form_field->addControlSection("field_acceptance", __("Acceptance","wpfnl"), "assets/icon.png", $this);
        $field_acceptance->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Acceptance Checkbox","wpfnl"),
                "slug" => 'acceptance_checkbox',
                "default" => "off"
            )
        )->setValue(array(
            'on'       => __('Yes',"wpfnl" ),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();

        //Acceptance Text
        $field_acceptance->addOptionControl(
            array(
                "type" => 'content',
                "name" => __("Acceptance Text","wpfnl"),
                "slug" => 'acceptance_checkbox_text',
                "default" => __("I have read and agree the Terms & Condition.","wpfnl"),
                "condition" => 'acceptance_checkbox=on',
            )
        )->rebuildElementOnChange();

        $field_acceptance->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Mark Acceptance As Required","wpfnl"),
                "slug" => 'is_required_acceptance',
                "default" => "off",
                "condition" => 'acceptance_checkbox=on',
            )
        )->setValue(array(
            'on'       => __('Yes' ,"wpfnl"),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();


        //Input field Icon
        $field_icon = $form_field->addControlSection("field_icon", __("Fiels Icon","wpfnl"), "assets/icon.png", $this);
        $field_icon->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Show Input Field Icon(s)","wpfnl"),
                "slug" => 'input_fields_icon',
                "default" => "off"
            )
        )->setValue(array(
            'on'       => __('Yes' ,"wpfnl"),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();

        //Input field Label
        $field_label = $form_field->addControlSection("field_label", __("Field Label","wpfnl"), "assets/icon.png", $this);
        $field_label->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Show Field Label(s)","wpfnl"),
                "slug" => 'field_label',
                "default" => "off"
            )
        )->setValue(array(
            'on'       => __('Yes',"wpfnl" ),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();

        //Input field Require Mark
        $field_label->addOptionControl(
            array(
                "type" => 'dropdown',
                "name" => __("Show Field Required Mark","wpfnl"),
                "slug" => 'field_required_mark',
                "default" => "off"
            )
        )->setValue(array(
            'on'       => __('Yes',"wpfnl" ),
            'off'       => __('No',"wpfnl" ),
        ))->rebuildElementOnChange();


        //Button Text
        $button = $this->addControlSection("optin_form_button", __("Form Button","wpfnl"), "assets/icon.png", $this);
        $button_selector = '.wpfnl-optin-form-group .btn-optin-oxygen';

        $button->addOptionControl(
            array(
                "type" => 'textfield',
                "name" => __("Button Text","wpfnl"),
                "slug" => 'button_text',
                "default" => "Submit"
            )
        )->rebuildElementOnChange();

		$button->typographySection(
			__("Typography","wpfnl"),
			$button_selector."",
			$this
		);
		$button->borderSection(
			__("Button Border","wpfnl"),
			$button_selector."",
			$this
		);
		$button->addPreset(
			"padding",
			"menu_item_padding",
			__("Button Padding","wpfnl"),
			$button_selector
		)->whiteList();

		$button->addPreset(
			"margin",
			"menu_item_margin",
			__("Button Margin","wpfnl"),
			$button_selector
		)->whiteList();

		$button->addStyleControls(
			array(
				array(
					"name" => __('Background Color',"wpfnl"),
					"selector" => $button_selector."",
					"property" => 'background-color',
				),
				array(
					"name" => __('Background Hover Color',"wpfnl"),
					"selector" => $button_selector.":hover",
					"property" => 'background-color',
				),

			)
		);

		//Form style
		$form_style = $this->addControlSection("optin_form_style", __("Form Label Style","wpfnl"), "assets/icon.png", $this);
		$form_selector = '.wpfnl-optin-form form';

		$form_style->typographySection(
			__("Typography","wpfnl"),
			".wpfnl-optin-form .wpfnl-optin-form-group > label",
			$this
		);
		$form_style->addStyleControls(
			array(
				array(
					"name" => __('Checkbox Size',"wpfnl"),
					"selector" => ".wpfnl-optin-form .wpfnl-optin-form-group > label .check-box",
					"property" => 'width|height',
					"control_type" => 'slider-measurebox',
					"unit" => 'px'
				),

				array(
					"name" => __('Checkbox Spacing',"wpfnl"),
					"selector" => ".wpfnl-optin-form .wpfnl-optin-form-group.acceptance-checkbox > label, .wpfnl-optin-form .wpfnl-optin-form-group.user-registration-checkbox > label",
					"property" => 'padding-left',
					"control_type" => 'slider-measurebox',
					"unit" => 'px'
				),
				array(
					"name" => __('Row Spacing',"wpfnl"),
					"selector" => ".wpfnl-optin-form .wpfnl-optin-form-group:not(:last-child)",
					"property" => 'margin-bottom',
					"control_type" => 'slider-measurebox',
					"unit" => 'px'
				),
			)
		);

		$input_style = $this->addControlSection("optin_form_input_style", __("Form Input Style","wpfnl"), "assets/icon.png", $this);

		$input_style->typographySection(
			__("Typography","wpfnl"),
			".wpfnl-optin-form .wpfnl-optin-form-group input, .wpfnl-optin-form .wpfnl-optin-form-group textarea",
			$this
		);
		$input_style->borderSection(
			__("Button Border","wpfnl"),
			".wpfnl-optin-form .wpfnl-optin-form-group input, .wpfnl-optin-form .wpfnl-optin-form-group textarea",
			$this
		);
		$input_style->addStyleControls(
			array(
				array(
					"name" => __('Background Color',"wpfnl"),
					"selector" => ".wpfnl-optin-form .wpfnl-optin-form-group input, .wpfnl-optin-form .wpfnl-optin-form-group textarea",
					"property" => 'background-color',
				),

			)
		);




		//Admin Email
		$ac_submit = $this->addControlSection("optin_after_submit", __("Action After Submission","wpfnl"), "assets/icon.png", $this);
		$admin_email = get_option( 'admin_email' );
		$ac_submit->addOptionControl(
			array(
				"type" => 'textfield',
				"name" => __("Admin Email","wpfnl"),
				"slug" => 'admin_email',
				"default" => $admin_email
			)
		)->rebuildElementOnChange();

		//Admin Email Subject
		$ac_submit->addOptionControl(
			array(
				"type" => 'textfield',
				"name" => __("Admin Email Subject","wpfnl"),
				"slug" => 'admin_email_subject',
				"default" => "New Form Submission"
			)
		)->rebuildElementOnChange();

		//Notification Text
		$ac_submit->addOptionControl(
			array(
				"type" => 'textfield',
				"name" => __("Notification Text","wpfnl"),
				"slug" => 'notification_text',
				"default" => "Thank you! Your form was submitted successfully!"
			)
		)->rebuildElementOnChange();

		// Other action
		$ac_submit->addOptionControl(
			array(
				"type" => 'dropdown',
				"name" => __("Other action","wpfnl"),
				"slug" => 'other_action',
				"default" => "notification"
			)
		)->setValue(array(
			'notification'    => __( 'None','wpfnl' ),
			'redirect_to'     => __( 'Redirect to url','wpfnl' ),
			'next_step'       => __( 'Next Step','wpfnl' ),
		))->rebuildElementOnChange();

		//Redirect URL
		$ac_submit->addOptionControl(
			array(
				"type" => 'textfield',
				"name" => __("Redirect url","wpfnl"),
				"slug" => 'redirect_url',
				"default" => "",
				"condition" => 'other_action=redirect_to',
			)
		)->rebuildElementOnChange();


		//Send data to Checkout
		$ac_submit->addOptionControl(
			array(
				"type" => 'dropdown',
				"name" => __("Carry data to the Next Form","wpfnl"),
				"slug" => 'data_to_checkout',
				"default" => "off"
			)
		)->setValue(array(
			'off'       => __('No',"wpfnl" ),
			'on'       => __('Yes',"wpfnl" ),
		))->rebuildElementOnChange();

		//Optin Registration
		$ac_submit->addOptionControl(
			array(
				"type" => 'dropdown',
				"name" => __("Register User As Subscriber","wpfnl"),
				"slug" => 'register_as_subscriber',
				"default" => "off"
			)
		)->setValue(array(
			'off'       => __('No',"wpfnl" ),
			'on'       => __('Yes',"wpfnl" ),
		))->rebuildElementOnChange();

		// Subscribed permission
		$ac_submit->addOptionControl(
			array(
				"type" => 'dropdown',
				"name" => __("Registration Permission","wpfnl"),
				"slug" => 'subscription_permission',
				"default" => "off",
				"condition" => 'register_as_subscriber=on',
			)
		)->setValue(array(
			'off'       => __('No',"wpfnl" ),
			'on'       => __('Yes',"wpfnl" ),
		))->rebuildElementOnChange();
		// Subscribed permission Text
		$ac_submit->addOptionControl(
			array(
				"type" => 'textfield',
				"name" => __("Registration Permission Text","wpfnl"),
				"slug" => 'subscription_permission_text',
				"default" => __("I agree to be registered as a subscriber.","wpfnl"),
				"condition" => 'subscription_permission=on',
			)
		)->rebuildElementOnChange();


    }

    function defaultCSS() {

    }


}
